Index: trunk/LMDZ.GENERIC/README
===================================================================
--- trunk/LMDZ.GENERIC/README	(revision 2541)
+++ trunk/LMDZ.GENERIC/README	(revision 2542)
@@ -1662,2 +1662,8 @@
 ==16/06/2021 == MT
 - Add the Surface SW spectrum in diagspecVI netcdf output file (useful as a diagnostic of surface radiation condition for e.g. habitability studies)
+
+== 05/07/2021 == YJ
+Large update of the chemical modules
+- Read chemical network from input files
+- Init chemistry with ModernTrac
+- Photolysis online calculation
Index: trunk/LMDZ.GENERIC/deftank/traceur.def.modern
===================================================================
--- trunk/LMDZ.GENERIC/deftank/traceur.def.modern	(revision 2541)
+++ trunk/LMDZ.GENERIC/deftank/traceur.def.modern	(revision 2542)
@@ -22,21 +22,34 @@
 #               only mandatory information ! But you can specify all the options you
 #               want in separate blocks following 'option=value', assuming this option
-#               is defined in traceur_h.F90 & initracer.F for physics or infotrac.F90 
-#               for dynamics. Indeed this file is read once by dynamics who keep only
-#               the information needed and re-read by physics.
+#               is defined in traceur_h.F90 & initracer.F for physics, infotrac.F90 
+#               for dynamics or chimiedata_h.F90 & calchim_asis.F90 for chemistry.
+#               Indeed this file is read once by dynamics, once by physics and once by
+#               chemistry who keep only the information needed.
 #
 #               Note that by default a tracer listed below will be sent to dynamics
 #               except if you specify is_dyn=0. If nothing is given, then is_dyn=1.
+#               Not yet fully implemented.
 #
 # 3. Options.   Implemented options listed below.
 # ~~~~~~~~~~~~  For dynamic see "infotrac.F90".
 #               For physic see "initracer.F90".
+#               For chemistry see "calchim_asis.F90".
+#                        init see "inichim_1D.F90" and "inichim_newstart.F90"
 #
-# Dynamic:      vadv        ! index of vertical trasport schema
-#               hadv        ! index of horizontal trasport schema
-#               tnom_transp ! transporting fluid short name: CRisi
+# Dynamic:      vadv           ! index of vertical trasport schema
+#               hadv           ! index of horizontal trasport schema
+#               tnom_transp    ! transporting fluid short name: CRisi
 #
-# Physic:       mmol        ! mole mass of tracer (g/mol-1)
+# Physic:       mmol           ! mole mass of tracer [g.mol-1]
+#               aki            ! coefficient of thermal concduction
+#               cpi            ! heat capacity [J.kg-1.K-1]
+#               is_chim        ! 1 if tracer used in chemistry, else 0
 #
+# Chemistry:    SF_mode        ! 1 if surface set up value, else 2 sedimentation velocity
+#               SF_value       ! [vmr] if SF_mode=1, else [cm.s-1]
+#               prod_rate      ! if SF_mode=2 production flux [molecules.m-2.s-1]
+#
+#      init:    qx             ! value that initialize constant profile [vmr]
+#               qxf            ! file that initialize profile [Pa,vmr] (1 line header)
 #
 #
Index: trunk/LMDZ.GENERIC/libf/aeronostd/calchim_asis.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/calchim_asis.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/calchim_asis.F90	(revision 2542)
@@ -3,15 +3,15 @@
                          zzlev,zzlay,zday,pq,pdq,dqchim,dqschim,            &
                          tauref,co2ice,                                     &
-                         pu,pdu,pv,pdv,surfdust,surfice)
-
-      use tracer_h, only:   igcm_co2, igcm_co, igcm_o, igcm_o1d, igcm_o2, &
-                            igcm_o3, igcm_h, igcm_h2, igcm_oh, igcm_ho2,  &
-                            igcm_h2o2, igcm_ch4, igcm_n2, igcm_h2o_vap,   &
-                            igcm_n, igcm_no, igcm_no2, igcm_n2d,   &
-                            mmol
+                         pu,pdu,pv,pdv,surfdust,surfice,icount,zdtchim)
+
+      use tracer_h, only: mmol, noms, nesp, is_chim
 
       use conc_mod, only: mmean ! mean molecular mass of the atmosphere
       USE comcstfi_mod
       use callkeys_mod
+      use time_phylmdz_mod, only: ecritphy, iphysiq ! output rate set by ecritphy
+      use types_asis,       only: v_phot_3d, jlabel, nb_phot_hv_max
+      use chimiedata_h
+      use radcommon_h,      only: glat
 
       implicit none
@@ -35,4 +35,5 @@
 !    update 11/12/2013 optimization (Franck Lefevre)
 !    update 20/10/2017 adapted to LMDZ GENERIC+cosmetic changes (Benjamin Charnay)
+!    update 06/03/2021 generic tracer/network + photolysis online (Yassin Jaziri)
 !
 !   Arguments:
@@ -62,10 +63,8 @@
 !  Output:
 !
-!    dqchim(ngrid,nlayer,nq) ! tendencies on pq due to chemistry
-!    dqschim(ngrid,nq)         ! tendencies on qsurf 
-!
-!=======================================================================
-
-#include "chimiedata.h"
+!    dqchim(ngrid,nlayer,nesp)   ! tendencies on pq due to chemistry
+!    dqschim(ngrid,nesp)         ! tendencies on qsurf 
+!
+!=======================================================================
 
 !     input:
@@ -76,5 +75,5 @@
       real :: ptimestep
       real :: pplay(ngrid,nlayer)    ! pressure at the middle of the layers
-      real :: zzlay(ngrid,nlayer)    ! pressure at the middle of the layers
+      real :: zzlay(ngrid,nlayer)    ! altitude at the middle of the layers
       real :: pplev(ngrid,nlayer+1)  ! intermediate pressure levels
       real :: zzlev(ngrid,nlayer+1)  ! altitude at layer boundaries
@@ -97,39 +96,15 @@
 !     output:
 
-      real :: dqchim(ngrid,nlayer,nq)   ! tendencies on pq due to chemistry
-      real :: dqschim(ngrid,nq)         ! tendencies on qsurf 
+      real :: dqchim(ngrid,nlayer,nesp)   ! tendencies on pq due to chemistry
+      real :: dqschim(ngrid,nesp)         ! tendencies on qsurf 
 
 !     local variables:
 
-      integer,save :: nbq                   ! number of tracers used in the chemistry
-      integer,allocatable,save :: niq(:)    ! array storing the indexes of the tracers
-      integer :: iloc(1)                    ! index of major species
-      integer :: ig,l,i,iq,iqmax
-      integer :: foundswitch, lswitch
+      integer :: iloc(1)                  ! index of major species
+      integer :: ig,l,i,iq,iqmax,iesp
+      integer :: foundswitch, lswitch     ! to switch between photochem and thermochem ? (YJ)
       integer,save :: chemthermod
 
-      integer,save :: i_co2  = 0
-      integer,save :: i_co   = 0
-      integer,save :: i_o    = 0
-      integer,save :: i_o1d  = 0
-      integer,save :: i_o2   = 0
-      integer,save :: i_o3   = 0
-      integer,save :: i_h    = 0
-      integer,save :: i_h2   = 0
-      integer,save :: i_oh   = 0
-      integer,save :: i_ho2  = 0
-      integer,save :: i_h2o2 = 0
-      integer,save :: i_ch4  = 0
-      integer,save :: i_n2   = 0
-      integer,save :: i_h2o  = 0
-      integer,save :: i_n    = 0
-      integer,save :: i_no    = 0
-      integer,save :: i_no2    = 0
-      integer,save :: i_n2d    = 0
-
-      integer :: ig_vl1
-
-      real    :: latvl1, lonvl1
-      real    :: zq(ngrid,nlayer,nq)   ! pq+pdq*ptimestep before chemistry
+      real    :: zq(ngrid,nlayer,nesp) ! pq+pdq*ptimestep before chemistry
                                        ! new mole fraction after
       real    :: zt(ngrid,nlayer)      ! temperature
@@ -137,7 +112,7 @@
       real    :: zv(ngrid,nlayer)      ! v component of the wind
       real    :: taucol                ! optical depth at 7 hPa
-
+      real    :: xmmol(nlayer,nesp)    ! mmol/mmean but only for chemical species
+ 
       logical,save :: firstcall = .true.
-      logical,save :: depos = .false.  ! switch for dry deposition
 
 !     for each column of atmosphere:
@@ -147,5 +122,5 @@
       real :: ztemp(nlayer)        ! Temperature (K)
       real :: zlocal(nlayer)       ! Altitude (km)
-      real :: zycol(nlayer,nq)     ! Composition (mole fractions)
+      real :: zycol(nlayer,nesp)   ! Composition (mole fractions)
       real :: zmmean(nlayer)       ! Mean molecular mass (g.mole-1)
       real :: szacol               ! Solar zenith angle
@@ -154,16 +129,18 @@
       real :: surfice1d(nlayer)    ! Ice surface area (cm2/cm3)
       real :: surfdust1d(nlayer)   ! Dust surface area (cm2/cm3)
-      real :: jo3(nlayer)          ! Photodissociation rate O3->O1D (s-1)
 
       integer :: iter(nlayer)      !  Number of chemical iterations
                                    !  within one physical timestep 
-
+      integer :: icount
 !     for output:
 
-      logical :: output             ! to issue calls to writediagfi and stats
+      logical :: output              ! to issue calls to writediagfi and stats
       parameter (output = .true.)
-      real :: jo3_3d(ngrid,nlayer)  ! Photodissociation rate O3->O1D (s-1)
-      real :: iter_3d(ngrid,nlayer) ! Number of chemical iterations
-                                    !  within one physical timestep
+      real :: iter_3d(ngrid,nlayer)  ! Number of chemical iterations
+                                     !  within one physical timestep
+      integer           ::  ierr
+      real              ::  zdtchim(ngrid,nlayer)    ! temperature modification by chemistry
+      real              ::  dEzchim(ngrid,nlayer)    ! energy modification by chemistry
+      real              ::  zdtchim_output(ngrid)    ! flux modification by chemistry in W.m-2
 
 !=======================================================================
@@ -173,203 +150,41 @@
       if (firstcall) then
 
-         if (photochem) then
-            print*,'calchim: Read photolysis lookup table'
-            call read_phototable
-         end if
-         ! find index of chemical tracers to use
-         allocate(niq(nq))
-         ! Listed here are all tracers that can go into photochemistry
-         nbq = 0 ! to count number of tracers
-         ! Species ALWAYS present if photochem=.T. or thermochem=.T.
-         i_co2 = igcm_co2
-         if (i_co2 == 0) then
-            write(*,*) "calchim: Error; no CO2 tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_co2
-         end if
-         i_co = igcm_co
-         if (i_co == 0) then
-            write(*,*) "calchim: Error; no CO tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_co
-         end if
-         i_o = igcm_o
-         if (i_o == 0) then
-            write(*,*) "calchim: Error; no O tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_o
-         end if
-         i_o1d = igcm_o1d
-         if (i_o1d == 0) then
-            write(*,*) "calchim: Error; no O1D tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_o1d
-         end if
-         i_o2 = igcm_o2
-         if (i_o2 == 0) then
-            write(*,*) "calchim: Error; no O2 tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_o2
-         end if
-         i_o3 = igcm_o3
-         if (i_o3 == 0) then
-            write(*,*) "calchim: Error; no O3 tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_o3
-         end if
-         i_h = igcm_h
-         if (i_h == 0) then
-            write(*,*) "calchim: Error; no H tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_h
-         end if
-         i_h2 = igcm_h2
-         if (i_h2 == 0) then
-            write(*,*) "calchim: Error; no H2 tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_h2
-         end if
-         i_oh = igcm_oh
-         if (i_oh == 0) then
-            write(*,*) "calchim: Error; no OH tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_oh
-         end if
-         i_ho2 = igcm_ho2
-         if (i_ho2 == 0) then
-            write(*,*) "calchim: Error; no HO2 tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_ho2
-         end if
-         i_h2o2 = igcm_h2o2
-         if (i_h2o2 == 0) then
-            write(*,*) "calchim: Error; no H2O2 tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_h2o2
-         end if
-         i_ch4 = igcm_ch4
-         if (i_ch4 == 0) then
-            write(*,*) "calchim: Error; no CH4 tracer !!!"
-            write(*,*) "CH4 will be ignored in the chemistry"
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_ch4
-         end if
-         i_n2 = igcm_n2
-         if (i_n2 == 0) then
-            write(*,*) "calchim: Error; no N2 tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_n2
-         end if
-         i_n = igcm_n
-         if (i_n == 0) then
-            if (photochem) then
-               write(*,*) "calchim: Error; no N tracer !!!"
-               write(*,*) "N will be ignored in the chemistry"
+!! Moved to routine indice in photochemistry_asis
+!! because nb_phot_hv_max value needed in order
+!! to choose if we call read_phototable or not.
+!! A cleaner solution need to be find.
+!         if (photochem .and. .not. jonline) then
+!           print*,'calchim: Read photolysis lookup table'
+!           call read_phototable
+!         end if
+
+         if (.not.allocated(SF_mode))       allocate(SF_mode(nesp))
+         if (.not.allocated(SF_value))      allocate(SF_value(nesp))
+         if (.not.allocated(prod_rate))     allocate(prod_rate(nesp))
+         if (.not.allocated(surface_flux))  allocate(surface_flux(ngrid,nesp))
+         if (.not.allocated(surface_flux2)) allocate(surface_flux2(ngrid,nesp))
+         if (.not.allocated(escape))        allocate(escape(ngrid,nesp))
+         if (.not.allocated(chemnoms))      allocate(chemnoms(nesp))
+
+         surface_flux(:,:)  = 0.
+         surface_flux2(:,:) = 0.
+         escape(:,:)        = 0.
+         SF_mode(:)         = 2
+         SF_value(:)        = 0.
+         prod_rate(:)       = 0.
+         iter_3d(:,:)       = 0.
+         iter(:)            = 0.
+
+         call ini_tracchim
+
+         ! Sanity check mmol /= 0. in chemistry
+         do iq = 1,nq
+            if (is_chim(iq).eq.1 .and. mmol(iq).eq.0.) then
+               write(*,*) 'Error in calchim:'
+               write(*,*) 'Mmol cannot be equal to 0 for chemical species'
+               stop
             end if
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_n
-         end if
-         i_n2d = igcm_n2d
-         if (i_n2d == 0) then
-            if (photochem) then
-               write(*,*) "calchim: Error; no N2D tracer !!!"
-               write(*,*) "N2d will be ignored in the chemistry"
-            end if
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_n2d
-         end if
-         i_no = igcm_no
-         if (i_no == 0) then
-            if (photochem) then
-               write(*,*) "calchim: Error; no NO tracer !!!"
-               write(*,*) "NO will be ignored in the chemistry"
-            end if
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_no
-         end if
-         i_no2 = igcm_no2
-         if (i_no2 == 0) then
-            if (photochem) then
-               write(*,*) "calchim: Error; no NO2 tracer !!!"
-               write(*,*) "NO2 will be ignored in the chemistry"
-            end if
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_no2
-         end if
-         i_h2o = igcm_h2o_vap
-         if (i_h2o == 0) then
-            write(*,*) "calchim: Error; no water vapor tracer !!!"
-            stop
-         else
-            nbq = nbq + 1
-            niq(nbq) = i_h2o
-         end if
-         !Check tracers needed for thermospheric chemistry
-!         if(thermochem) then
-!            chemthermod=0  !Default: C/O/H chemistry
-!            !Nitrogen chemistry
-!            !NO is used to determine if N chemistry is wanted
-!            !chemthermod=2 -> N chemistry
-!            if (i_no == 0) then
-!               write(*,*) "calchim: no NO tracer"
-!               write(*,*) "C/O/H themosp chemistry only "
-!            else
-!               chemthermod=2
-!               write(*,*) "calchim: NO in traceur.def"
-!               write(*,*) "Nitrogen chemistry included"
-!            end if
-!            ! N
-!            if(chemthermod == 2) then
-!               if (i_n == 0) then
-!                  write(*,*) "calchim: Error; no N tracer !!!"
-!                  write(*,*) "N is needed if NO is in traceur.def"
-!                  stop
-!               end if
-!            ! NO2
-!               if (i_no2 == 0) then
-!                  write(*,*) "calchim: Error; no NO2 tracer !!!"
-!                  write(*,*) "NO2 is needed if NO is in traceur.def"
-!                  stop
-!               end if
-!            ! N(2D)
-!               if (i_n2d == 0) then
-!                  write(*,*) "calchim: Error; no N2D !!!"
-!                  write(*,*) "N2D is needed if NO is in traceur.def"
-!                  stop
-!               end if
-!            endif    !Of if(chemthermod == 2)
-!         endif      !Of thermochem
-
-         write(*,*) 'calchim: found nbq    = ',nbq,' tracers'
-               
+         end do
+
          firstcall = .false.
       end if ! if (firstcall)
@@ -380,9 +195,4 @@
       dqchim(:,:,:) = 0.
       dqschim(:,:)  = 0.
-
-!     latvl1= 22.27
-!     lonvl1= -47.94
-!     ig_vl1= 1+ int( (1.5-(latvl1-90.)*jjm/180.)  -2 )*iim +    &
-!             int(1.5+(lonvl1+180)*iim/360.)
 
 !=======================================================================
@@ -394,9 +204,14 @@
          foundswitch = 0
          do l = 1,nlayer
-            do i = 1,nbq
-               iq = niq(i) ! get tracer index
-               zq(ig,l,iq) = pq(ig,l,iq) + pdq(ig,l,iq)*ptimestep
-               zycol(l,iq) = zq(ig,l,iq)*mmean(ig,l)/mmol(iq)
-            end do
+            iesp = 0
+            do iq = 1,nq
+               if (is_chim(iq).eq.1) then
+                  iesp = iesp + 1
+                  zq(ig,l,iesp) = pq(ig,l,iq) + pdq(ig,l,iq)*ptimestep
+                  xmmol(l,iesp) = mmol(iq)/mmean(ig,l)
+                  zycol(l,iesp) = zq(ig,l,iesp)/xmmol(l,iesp)
+               end if
+            end do
+
             zt(ig,l)  = pt(ig,l) + pdt(ig,l)*ptimestep
             zu(ig,l)  = pu(ig,l) + pdu(ig,l)*ptimestep
@@ -430,7 +245,7 @@
          end do ! of do l=1,nlayer
 
-         szacol = acos(mu0(ig))*180./pi
-         taucol = tauref(ig)*(700./610.)  ! provisoire en attente de nouveau jmars
-         fractcol=fract(ig)
+         szacol   = acos(mu0(ig))*180./pi
+         taucol   = tauref(ig)*(700./610.)  ! provisoire en attente de nouveau jmars
+         fractcol = fract(ig)
 
 !=======================================================================
@@ -440,24 +255,21 @@
 !        chemistry in lower atmosphere
 
-         if (photochem) then
-
-            call photochemistry_asis(nlayer,nq,ngrid,                          &
-                                ig,lswitch,zycol,szacol,fractcol,ptimestep,    &
-                                zpress,ztemp,zdens,zmmean,dist_sol,            &
-                                surfdust1d,surfice1d,jo3,taucol,iter)
-
-!        ozone photolysis, for output
-
+!         if (photochem) then
+
+            call photochemistry_asis(nlayer,ngrid,                         &
+                                ig,lswitch,zycol,szacol,fractcol,ptimestep,&
+                                zpress,zlocal,ztemp,zdens,zmmean,dist_sol, &
+                                surfdust1d,surfice1d,taucol,iter,zdtchim(ig,:))
+
+            ! diagnostic photochemical heating
+            zdtchim_output(ig) = 0.
             do l = 1,nlayer
-               jo3_3d(ig,l) = jo3(l)
+              dEzchim(ig,l) = zdtchim(ig,l)*cpp*(pplev(ig,l) - pplev(ig,l+1))/glat(ig)
+              zdtchim_output(ig) = zdtchim_output(ig) + zdtchim(ig,l)*cpp*(pplev(ig,l) - pplev(ig,l+1))/glat(ig)
+            end do
+
+            do l = 1,nlayer
                iter_3d(ig,l) = iter(l)
             end do
-
-!        condensation of h2o2
-
-!            call perosat(ngrid, nlayer, nq,                        &
-!                         ig,ptimestep,pplev,pplay,                 &
-!                         ztemp,zycol,dqcloud,dqscloud)
-         end if
 
 !        chemistry in upper atmosphere
@@ -470,9 +282,18 @@
 !        dry deposition
 
-!         if (depos) then
-!            call deposition(ngrid, nlayer, nq,                      &
-!                            ig, ig_vl1, pplay, pplev, zzlay, zzlev, & 
-!                            zu, zv, zt, zycol, ptimestep, co2ice)
-!         end if
+         if (depos) then
+            call deposition_source(ngrid, nlayer, nq,   &
+                        ig, zzlay, zzlev, zdens, zycol, ptimestep)
+            surface_flux2(ig,:) = surface_flux2(ig,:) + surface_flux(ig,:)
+            if (ngrid==1) then
+              if(mod(icount,ecritphy).eq.0) then
+                surface_flux2(ig,:) = surface_flux2(ig,:)/float(ecritphy)
+              endif
+            else
+              if(mod(icount*iphysiq,ecritphy).eq.0) then
+                surface_flux2(ig,:) = surface_flux2(ig,:)*iphysiq/float(ecritphy)
+              endif
+            endif
+         end if
 
 !=======================================================================
@@ -489,12 +310,12 @@
             iloc=maxloc(zycol(l,:))
             iqmax=iloc(1)
-            do i = 1,nbq
-               iq = niq(i) ! get tracer index
+            do iq = 1,nesp
                if (iq /= iqmax) then
-                  dqchim(ig,l,iq) = (zycol(l,iq)*mmol(iq)/mmean(ig,l) - zq(ig,l,iq))/ptimestep
+                  dqchim(ig,l,iq) = (zycol(l,iq)*xmmol(l,iq) - zq(ig,l,iq))/ptimestep
                   dqchim(ig,l,iq) = max(dqchim(ig,l,iq),-zq(ig,l,iq)/ptimestep)
                   dqchim(ig,l,iqmax) = dqchim(ig,l,iqmax) - dqchim(ig,l,iq) 
                end if
             end do
+
          end do ! of do l = 1,nlayer
 
@@ -508,5 +329,5 @@
 !=======================================================================
 
-      end do ! of do ig=1,ngrid
+      end do ! of do ig=1,ngridbidon(ig,:) = 1
 
 !=======================================================================
@@ -516,18 +337,167 @@
 ! value of parameter 'output' to trigger writting of outputs
 ! is set above at the declaration of the variable.
-
       if (photochem .and. output) then
-            call writediagfi(ngrid,'jo3','j o3->o1d',    &
-                             's-1',3,jo3_3d(1,1))
-            call writediagfi(ngrid,'iter','iterations',  &
+
+         if (callstats) then
+            ! photoloysis
+            do i=1,nb_phot_hv_max
+               call wstats(ngrid,trim(jlabel(i,1)),jlabel(i,1),    &
+                                's-1',3,v_phot_3d(1,1,i))
+            end do
+            ! iter
+            call wstats(ngrid,'iter','iterations',  &
                              ' ',3,iter_3d(1,1))
-            if (callstats) then
-               call wstats(ngrid,'jo3','j o3->o1d',       &
-                           's-1',3,jo3_3d(1,1))
-               call wstats(ngrid,'mmean','mean molecular mass',       &
+            ! phothcemical heating
+            call wstats(ngrid,'zdtchim','dT chim',    &
+                             'K.s-1',3,zdtchim)
+            call wstats(ngrid,'dEzchim','dE chim',    &
+                             'W m-2',3,dEzchim)
+            call wstats(ngrid,"Ezchim","integrated dT chim","W m-2",2,zdtchim_output)
+            ! Mean molecular mass
+            call wstats(ngrid,'mmean','mean molecular mass',       &
                            'g.mole-1',3,mmean(1,1))
+            ! Chemical tendencies
+            do iesp=1,nesp
+               call wstats(ngrid,trim(chemnoms(iesp))//'_dq',trim(chemnoms(iesp))//'_dq',    & 
+                               'kg/kg s^-1',3,dqchim(1,1,iesp) )
+            end do
+            if (depos) then
+               ! Surface fluxes
+               do iesp=1,nesp
+                  call wstats(ngrid,trim(chemnoms(iesp))//'_flux_mean',trim(chemnoms(iesp))//' mean flux',    & 
+                               'molecule.m-2.s-1',2,surface_flux2(1,indexchim(trim(chemnoms(iesp)))))
+                  call wstats(ngrid,trim(chemnoms(iesp))//'_flux',trim(chemnoms(iesp))//' flux',    & 
+                               'molecule.m-2.s-1',2,surface_flux(1,indexchim(trim(chemnoms(iesp)))))
+               end do
+            endif ! end depos
+         endif ! end callstats
+
+         ! photoloysis
+         do i=1,nb_phot_hv_max
+            call writediagfi(ngrid,trim(jlabel(i,1)),jlabel(i,1),    &
+                             's-1',3,v_phot_3d(1,1,i))
+         end do
+         ! iter
+         call writediagfi(ngrid,'iter','iterations',  &
+                          ' ',3,iter_3d(1,1))
+         ! phothcemical heating
+         call writediagfi(ngrid,'zdtchim','dT chim',    &
+                          'K.s-1',3,zdtchim)
+         call writediagfi(ngrid,'dEzchim','dE chim',    &
+                          'W m-2',3,dEzchim)
+         call writediagfi(ngrid,"Ezchim","integrated dT chim","W m-2",2,zdtchim_output)
+         ! Mean molecular mass
+         call writediagfi(ngrid,'mmean','mean molecular mass',       &
+                        'g.mole-1',3,mmean(1,1))
+         ! Chemical tendencies
+         do iesp=1,nesp
+            call writediagfi(ngrid,trim(chemnoms(iesp))//'_dq',trim(chemnoms(iesp))//'_dq',    & 
+                            'kg/kg s^-1',3,dqchim(1,1,iesp) )
+         end do
+         if (depos) then
+            ! Surface fluxes
+            do iesp=1,nesp
+               call writediagfi(ngrid,trim(chemnoms(iesp))//'_flux_mean',trim(chemnoms(iesp))//' mean flux',    & 
+                            'molecule.m-2.s-1',2,surface_flux2(1,indexchim(trim(chemnoms(iesp)))))
+               call writediagfi(ngrid,trim(chemnoms(iesp))//'_flux',trim(chemnoms(iesp))//' flux',    & 
+                            'molecule.m-2.s-1',2,surface_flux(1,indexchim(trim(chemnoms(iesp)))))
+            end do
+            ! Restart flux average
+            if (ngrid == 1) then
+               if(mod(icount,ecritphy).eq.0) then
+                  surface_flux2(:,:) = 0.0
+               endif
+            else
+               if(mod(icount*iphysiq,ecritphy).eq.0) then
+                  surface_flux2(:,:) = 0.0
+               endif
             endif
+         endif ! end depos
+
       end if ! of if (output)
 
       return
-      end
+
+
+      contains
+
+
+!======================================================================
+
+      subroutine ini_tracchim
+
+!======================================================================
+! YJ Modern tracer.def
+! Get in tracer.def chemical parameters
+!======================================================================
+
+         use chimiedata_h
+         use tracer_h, only:   is_chim
+         implicit none
+
+         ! local
+         character(len=500) :: tracline ! to store a line of text
+         integer            :: nq       ! number of tracers
+         integer            :: iesp, iq
+
+         ! Get nq
+         open(90,file='traceur.def',status='old',form='formatted',iostat=ierr)
+         if (ierr.eq.0) then
+           READ(90,'(A)') tracline
+           IF (trim(tracline).ne.'#ModernTrac-v1') THEN ! Test modern traceur.def
+            READ(tracline,*,iostat=ierr) nq ! Try standard traceur.def
+           ELSE
+              DO
+                READ(90,'(A)',iostat=ierr) tracline
+                IF (ierr.eq.0) THEN
+                  IF (index(tracline,'#').ne.1) THEN ! Allows arbitary number of comments lines in the header
+                    READ(tracline,*,iostat=ierr) nq
+                    EXIT
+                  ENDIF
+                ELSE ! If pb, or if reached EOF without having found number of tracer
+                   write(*,*) "calchim: error reading line of tracers"
+                   write(*,*) "   (first lines of traceur.def) "
+                   stop
+                ENDIF
+              ENDDO
+           ENDIF ! if modern or standard traceur.def
+         else
+            write(*,*) "calchim: error opening traceur.def"
+            stop
+         endif
+
+         ! Get data of tracers
+         iesp = 0
+         do iq=1,nq
+            read(90,'(A)') tracline
+            if (is_chim(iq).eq.1) then
+               iesp = iesp + 1
+               read(tracline,*) chemnoms(iesp)
+               write(*,*)"ini_tracchim: iq=",iq,"noms(iq)=",trim(chemnoms(iesp))
+               if (index(tracline,'SF_mode='    ) /= 0) then
+                  read(tracline(index(tracline,'SF_mode=')+len('SF_mode='):),*) SF_mode(iesp)
+                  write(*,*) ' Parameter value (traceur.def) : SF_mode=', SF_mode(iesp)
+               else
+                  write(*,*) ' Parameter value (default)     : SF_mode=', SF_mode(iesp)
+               end if
+               if (index(tracline,'SF_value='    ) /= 0) then
+                  read(tracline(index(tracline,'SF_value=')+len('SF_value='):),*) SF_value(iesp)
+                  write(*,*) ' Parameter value (traceur.def) : SF_value=', SF_value(iesp)
+               else
+                  write(*,*) ' Parameter value (default)     : SF_value=', SF_value(iesp)
+               end if
+               if (index(tracline,'prod_rate='    ) /= 0) then
+                  read(tracline(index(tracline,'prod_rate=')+len('prod_rate='):),*) prod_rate(iesp)
+                  write(*,*) ' Parameter value (traceur.def) : prod_rate=', prod_rate(iesp)
+               else
+                  write(*,*) ' Parameter value (default)     : prod_rate=', prod_rate(iesp)
+               end if
+            end if
+         end do
+
+         close(90)
+
+      end subroutine ini_tracchim
+
+      end subroutine calchim_asis
+
